function xsim = ms_simulation(Ahat,Fhat,Zhat,ehat,ST,phi,fss)
%
% Simulate a Markov-switching VAR model 
%
% by Stephane Lhuissier

nvar = size(Ahat,1);
lags = (size(Fhat,1)-1)/nvar;

xinit  = zeros(nvar*lags+1,fss); % nexo
vector = zeros(fss,nvar);

xinit(:,1) = phi; % initialization

 for t=1:fss
         
    epsylon=ehat(t,:)'; % generated shocks

    vector(t,:)  = xinit(:,t)'*(Fhat(1:end,:,ST(t))*inv(Ahat(:,:,ST(t))))+epsylon'*inv(sqrt(Zhat(:,:,ST(t))))*inv(Ahat(:,:,ST(t)));
    xinit(:,t+1) = [vector(t,1:nvar)';(xinit(1:end-nvar-1,t));(xinit(end,t)) ];

 end
 
 xsim = xinit(:,2:end);
 
 